Gnome XML Library Reference Manual
<<< Previous Page | Home | Up | Next Page >>>

# tree

## Name

tree --

## Synopsis

    #define     XML_XML_NAMESPACE
    enum        xmlElementType;
    typedef     xmlChar;
    #define     BAD_CAST
    struct      xmlNotation;
    typedef     xmlNotationPtr;
    enum        xmlAttributeType;
    enum        xmlAttributeDefault;
    struct      xmlEnumeration;
    typedef     xmlEnumerationPtr;
    struct      xmlAttribute;
    typedef     xmlAttributePtr;
    enum        xmlElementContentType;
    enum        xmlElementContentOccur;
    struct      xmlElementContent;
    typedef     xmlElementContentPtr;
    enum        xmlElementTypeVal;
    struct      xmlElement;
    typedef     xmlElementPtr;
    #define     XML_LOCAL_NAMESPACE
    typedef     xmlNsType;
    struct      xmlNs;
    typedef     xmlNsPtr;
    struct      xmlDtd;
    typedef     xmlDtdPtr;
    struct      xmlAttr;
    typedef     xmlAttrPtr;
    struct      xmlID;
    typedef     xmlIDPtr;
    struct      xmlRef;
    typedef     xmlRefPtr;
    enum        xmlBufferAllocationScheme;
    struct      xmlBuffer;
    typedef     xmlBufferPtr;
    struct      xmlNode;
    typedef     xmlNodePtr;
    struct      xmlDoc;
    typedef     xmlDocPtr;
    #define     xmlChildrenNode
    #define     xmlRootNode
    void        xmlSetBufferAllocationScheme    (xmlBufferAllocationScheme scheme);
    xmlBufferAllocationScheme xmlGetBufferAllocationScheme
                                                (void);
    xmlBufferPtr xmlBufferCreate                (void);
    xmlBufferPtr xmlBufferCreateSize            (size_t size);
    int         xmlBufferResize                 (xmlBufferPtr buf,
                                                 unsigned int size);
    void        xmlBufferFree                   (xmlBufferPtr buf);
    int         xmlBufferDump                   (FILE *file,
                                                 xmlBufferPtr buf);
    void        xmlBufferAdd                    (xmlBufferPtr buf,
                                                 const xmlChar *str,
                                                 int len);
    void        xmlBufferAddHead                (xmlBufferPtr buf,
                                                 const xmlChar *str,
                                                 int len);
    void        xmlBufferCat                    (xmlBufferPtr buf,
                                                 const xmlChar *str);
    void        xmlBufferCCat                   (xmlBufferPtr buf,
                                                 const char *str);
    int         xmlBufferShrink                 (xmlBufferPtr buf,
                                                 unsigned int len);
    int         xmlBufferGrow                   (xmlBufferPtr buf,
                                                 unsigned int len);
    void        xmlBufferEmpty                  (xmlBufferPtr buf);
    const xmlChar* xmlBufferContent             (const xmlBufferPtr buf);
    int         xmlBufferUse                    (const xmlBufferPtr buf);
    void        xmlBufferSetAllocationScheme    (xmlBufferPtr buf,
                                                 xmlBufferAllocationScheme scheme);
    int         xmlBufferLength                 (const xmlBufferPtr buf);
    xmlDtdPtr   xmlCreateIntSubset              (xmlDocPtr doc,
                                                 const xmlChar *name,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);
    xmlDtdPtr   xmlNewDtd                       (xmlDocPtr doc,
                                                 const xmlChar *name,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);
    xmlDtdPtr   xmlGetIntSubset                 (xmlDocPtr doc);
    void        xmlFreeDtd                      (xmlDtdPtr cur);
    xmlNsPtr    xmlNewGlobalNs                  (xmlDocPtr doc,
                                                 const xmlChar *href,
                                                 const xmlChar *prefix);
    xmlNsPtr    xmlNewNs                        (xmlNodePtr node,
                                                 const xmlChar *href,
                                                 const xmlChar *prefix);
    void        xmlFreeNs                       (xmlNsPtr cur);
    void        xmlFreeNsList                   (xmlNsPtr cur);
    xmlDocPtr   xmlNewDoc                       (const xmlChar *version);
    void        xmlFreeDoc                      (xmlDocPtr cur);
    xmlAttrPtr  xmlNewDocProp                   (xmlDocPtr doc,
                                                 const xmlChar *name,
                                                 const xmlChar *value);
    xmlAttrPtr  xmlNewProp                      (xmlNodePtr node,
                                                 const xmlChar *name,
                                                 const xmlChar *value);
    xmlAttrPtr  xmlNewNsProp                    (xmlNodePtr node,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *value);
    void        xmlFreePropList                 (xmlAttrPtr cur);
    void        xmlFreeProp                     (xmlAttrPtr cur);
    xmlAttrPtr  xmlCopyProp                     (xmlNodePtr target,
                                                 xmlAttrPtr cur);
    xmlAttrPtr  xmlCopyPropList                 (xmlNodePtr target,
                                                 xmlAttrPtr cur);
    xmlDtdPtr   xmlCopyDtd                      (xmlDtdPtr dtd);
    xmlDocPtr   xmlCopyDoc                      (xmlDocPtr doc,
                                                 int recursive);
    xmlNodePtr  xmlNewDocNode                   (xmlDocPtr doc,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *content);
    xmlNodePtr  xmlNewDocRawNode                (xmlDocPtr doc,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *content);
    xmlNodePtr  xmlNewNode                      (xmlNsPtr ns,
                                                 const xmlChar *name);
    xmlNodePtr  xmlNewChild                     (xmlNodePtr parent,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *content);
    xmlNodePtr  xmlNewTextChild                 (xmlNodePtr parent,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *content);
    xmlNodePtr  xmlNewDocText                   (xmlDocPtr doc,
                                                 const xmlChar *content);
    xmlNodePtr  xmlNewText                      (const xmlChar *content);
    xmlNodePtr  xmlNewPI                        (const xmlChar *name,
                                                 const xmlChar *content);
    xmlNodePtr  xmlNewDocTextLen                (xmlDocPtr doc,
                                                 const xmlChar *content,
                                                 int len);
    xmlNodePtr  xmlNewTextLen                   (const xmlChar *content,
                                                 int len);
    xmlNodePtr  xmlNewDocComment                (xmlDocPtr doc,
                                                 const xmlChar *content);
    xmlNodePtr  xmlNewComment                   (const xmlChar *content);
    xmlNodePtr  xmlNewCDataBlock                (xmlDocPtr doc,
                                                 const xmlChar *content,
                                                 int len);
    xmlNodePtr  xmlNewCharRef                   (xmlDocPtr doc,
                                                 const xmlChar *name);
    xmlNodePtr  xmlNewReference                 (xmlDocPtr doc,
                                                 const xmlChar *name);
    xmlNodePtr  xmlCopyNode                     (xmlNodePtr node,
                                                 int recursive);
    xmlNodePtr  xmlDocCopyNode                  (xmlNodePtr node,
                                                 xmlDocPtr doc,
                                                 int recursive);
    xmlNodePtr  xmlCopyNodeList                 (xmlNodePtr node);
    xmlNodePtr  xmlNewDocFragment               (xmlDocPtr doc);
    xmlNodePtr  xmlDocGetRootElement            (xmlDocPtr doc);
    xmlNodePtr  xmlGetLastChild                 (xmlNodePtr parent);
    int         xmlNodeIsText                   (xmlNodePtr node);
    int         xmlIsBlankNode                  (xmlNodePtr node);
    xmlNodePtr  xmlDocSetRootElement            (xmlDocPtr doc,
                                                 xmlNodePtr root);
    void        xmlNodeSetName                  (xmlNodePtr cur,
                                                 const xmlChar *name);
    xmlNodePtr  xmlAddChild                     (xmlNodePtr parent,
                                                 xmlNodePtr cur);
    xmlNodePtr  xmlAddChildList                 (xmlNodePtr parent,
                                                 xmlNodePtr cur);
    xmlNodePtr  xmlReplaceNode                  (xmlNodePtr old,
                                                 xmlNodePtr cur);
    xmlNodePtr  xmlAddSibling                   (xmlNodePtr cur,
                                                 xmlNodePtr elem);
    xmlNodePtr  xmlAddPrevSibling               (xmlNodePtr cur,
                                                 xmlNodePtr elem);
    xmlNodePtr  xmlAddNextSibling               (xmlNodePtr cur,
                                                 xmlNodePtr elem);
    void        xmlUnlinkNode                   (xmlNodePtr cur);
    xmlNodePtr  xmlTextMerge                    (xmlNodePtr first,
                                                 xmlNodePtr second);
    void        xmlTextConcat                   (xmlNodePtr node,
                                                 const xmlChar *content,
                                                 int len);
    void        xmlFreeNodeList                 (xmlNodePtr cur);
    void        xmlFreeNode                     (xmlNodePtr cur);
    void        xmlSetTreeDoc                   (xmlNodePtr tree,
                                                 xmlDocPtr doc);
    void        xmlSetListDoc                   (xmlNodePtr list,
                                                 xmlDocPtr doc);
    xmlNsPtr    xmlSearchNs                     (xmlDocPtr doc,
                                                 xmlNodePtr node,
                                                 const xmlChar *nameSpace);
    xmlNsPtr    xmlSearchNsByHref               (xmlDocPtr doc,
                                                 xmlNodePtr node,
                                                 const xmlChar *href);
    xmlNsPtr*   xmlGetNsList                    (xmlDocPtr doc,
                                                 xmlNodePtr node);
    void        xmlSetNs                        (xmlNodePtr node,
                                                 xmlNsPtr ns);
    xmlNsPtr    xmlCopyNamespace                (xmlNsPtr cur);
    xmlNsPtr    xmlCopyNamespaceList            (xmlNsPtr cur);
    xmlAttrPtr  xmlSetProp                      (xmlNodePtr node,
                                                 const xmlChar *name,
                                                 const xmlChar *value);
    xmlChar*    xmlGetProp                      (xmlNodePtr node,
                                                 const xmlChar *name);
    xmlAttrPtr  xmlHasProp                      (xmlNodePtr node,
                                                 const xmlChar *name);
    xmlAttrPtr  xmlHasNsProp                    (xmlNodePtr node,
                                                 const xmlChar *name,
                                                 const xmlChar *nameSpace);
    xmlAttrPtr  xmlSetNsProp                    (xmlNodePtr node,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *value);
    xmlChar*    xmlGetNsProp                    (xmlNodePtr node,
                                                 const xmlChar *name,
                                                 const xmlChar *nameSpace);
    xmlNodePtr  xmlStringGetNodeList            (xmlDocPtr doc,
                                                 const xmlChar *value);
    xmlNodePtr  xmlStringLenGetNodeList         (xmlDocPtr doc,
                                                 const xmlChar *value,
                                                 int len);
    xmlChar*    xmlNodeListGetString            (xmlDocPtr doc,
                                                 xmlNodePtr list,
                                                 int inLine);
    xmlChar*    xmlNodeListGetRawString         (xmlDocPtr doc,
                                                 xmlNodePtr list,
                                                 int inLine);
    void        xmlNodeSetContent               (xmlNodePtr cur,
                                                 const xmlChar *content);
    void        xmlNodeSetContentLen            (xmlNodePtr cur,
                                                 const xmlChar *content,
                                                 int len);
    void        xmlNodeAddContent               (xmlNodePtr cur,
                                                 const xmlChar *content);
    void        xmlNodeAddContentLen            (xmlNodePtr cur,
                                                 const xmlChar *content,
                                                 int len);
    xmlChar*    xmlNodeGetContent               (xmlNodePtr cur);
    xmlChar*    xmlNodeGetLang                  (xmlNodePtr cur);
    void        xmlNodeSetLang                  (xmlNodePtr cur,
                                                 const xmlChar *lang);
    int         xmlNodeGetSpacePreserve         (xmlNodePtr cur);
    void        xmlNodeSetSpacePreserve         (xmlNodePtr cur,
                                                 intval);
    xmlChar*    xmlNodeGetBase                  (xmlDocPtr doc,
                                                 xmlNodePtr cur);
    void        xmlNodeSetBase                  (xmlNodePtr cur,
                                                 xmlChar *uri);
    int         xmlRemoveProp                   (xmlAttrPtr attr);
    int         xmlRemoveNode                   (xmlNodePtr node);
    int         xmlUnsetProp                    (xmlNodePtr node,
                                                 const xmlChar *name);
    int         xmlUnsetNsProp                  (xmlNodePtr node,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name);
    void        xmlBufferWriteXmlCHAR           (xmlBufferPtr buf,
                                                 const xmlChar *string);
    void        xmlBufferWriteCHAR              (xmlBufferPtr buf,
                                                 const xmlChar *string);
    void        xmlBufferWriteChar              (xmlBufferPtr buf,
                                                 const char *string);
    void        xmlBufferWriteQuotedString      (xmlBufferPtr buf,
                                                 const xmlChar *string);
    int         xmlReconciliateNs               (xmlDocPtr doc,
                                                 xmlNodePtr tree);
    void        xmlDocDumpFormatMemory          (xmlDocPtr cur,
                                                 xmlChar **mem,
                                                 int *size,
                                                 int format);
    void        xmlDocDumpMemory                (xmlDocPtr cur,
                                                 xmlChar **mem,
                                                 int *size);
    void        xmlDocDumpMemoryEnc             (xmlDocPtr out_doc,
                                                 xmlChar **doc_txt_ptr,
                                                 int *doc_txt_len,
                                                 const char *txt_encoding);
    void        xmlDocDumpFormatMemoryEnc       (xmlDocPtr out_doc,
                                                 xmlChar **doc_txt_ptr,
                                                 int *doc_txt_len,
                                                 const char *txt_encoding,
                                                 int format);
    int         xmlDocDump                      (FILE *f,
                                                 xmlDocPtr cur);
    void        xmlElemDump                     (FILE *f,
                                                 xmlDocPtr doc,
                                                 xmlNodePtr cur);
    int         xmlSaveFile                     (const char *filename,
                                                 xmlDocPtr cur);
    int         xmlSaveFormatFile               (const char *filename,
                                                 xmlDocPtr cur,
                                                 int format);
    void        xmlNodeDump                     (xmlBufferPtr buf,
                                                 xmlDocPtr doc,
                                                 xmlNodePtr cur,
                                                 int level,
                                                 int format);
    int         xmlSaveFileEnc                  (const char *filename,
                                                 xmlDocPtr cur,
                                                 const char *encoding);
    int         xmlGetDocCompressMode           (xmlDocPtr doc);
    void        xmlSetDocCompressMode           (xmlDocPtr doc,
                                                 int mode);
    int         xmlGetCompressMode              (void);
    void        xmlSetCompressMode              (int mode);

## Description

## Details

### XML_XML_NAMESPACE

    #define     XML_XML_NAMESPACE

### enum xmlElementType

    typedef enum {
        XML_ELEMENT_NODE=		1,
        XML_ATTRIBUTE_NODE=		2,
        XML_TEXT_NODE=		3,
        XML_CDATA_SECTION_NODE=	4,
        XML_ENTITY_REF_NODE=	5,
        XML_ENTITY_NODE=		6,
        XML_PI_NODE=		7,
        XML_COMMENT_NODE=		8,
        XML_DOCUMENT_NODE=		9,
        XML_DOCUMENT_TYPE_NODE=	10,
        XML_DOCUMENT_FRAG_NODE=	11,
        XML_NOTATION_NODE=		12,
        XML_HTML_DOCUMENT_NODE=	13,
        XML_DTD_NODE=		14,
        XML_ELEMENT_DECL=		15,
        XML_ATTRIBUTE_DECL=		16,
        XML_ENTITY_DECL=		17,
        XML_NAMESPACE_DECL=		18,
        XML_XINCLUDE_START=		19,
        XML_XINCLUDE_END=		20
    #ifdef LIBXML_DOCB_ENABLED
       ,XML_DOCB_DOCUMENT_NODE=	21
    #endif
    } xmlElementType;

### xmlChar

This is a basic byte in an UTF-8 encoded string. It's unsigned allowing to pinpoint case where char * are assigned to xmlChar * (possibly making serialization back impossible).

### BAD_CAST

    #define     BAD_CAST

Macro to cast a string to an xmlChar * when one know its safe.

### struct xmlNotation

    struct xmlNotation {
        const xmlChar               *name;	        /* Notation name */
        const xmlChar               *PublicID;	/* Public identifier, if any */
        const xmlChar               *SystemID;	/* System identifier, if any */
    };

a DTD Notation definition

### xmlNotationPtr

### enum xmlAttributeType

    typedef enum {
        XML_ATTRIBUTE_CDATA = 1,
        XML_ATTRIBUTE_ID,
        XML_ATTRIBUTE_IDREF	,
        XML_ATTRIBUTE_IDREFS,
        XML_ATTRIBUTE_ENTITY,
        XML_ATTRIBUTE_ENTITIES,
        XML_ATTRIBUTE_NMTOKEN,
        XML_ATTRIBUTE_NMTOKENS,
        XML_ATTRIBUTE_ENUMERATION,
        XML_ATTRIBUTE_NOTATION
    } xmlAttributeType;

a DTD Attribute type definition

### enum xmlAttributeDefault

    typedef enum {
        XML_ATTRIBUTE_NONE = 1,
        XML_ATTRIBUTE_REQUIRED,
        XML_ATTRIBUTE_IMPLIED,
        XML_ATTRIBUTE_FIXED
    } xmlAttributeDefault;

a DTD Attribute default definition

### struct xmlEnumeration

    struct xmlEnumeration {
        struct _xmlEnumeration    *next;	/* next one */
        const xmlChar            *name;	/* Enumeration name */
    };

list structure used when there is an enumeration in DTDs

### xmlEnumerationPtr

### struct xmlAttribute

    struct xmlAttribute {
        void           *_private;	        /* for Corba, must be first ! */
        xmlElementType          type;       /* XML_ATTRIBUTE_DECL, must be second ! */
        const xmlChar          *name;	/* Attribute name */
        struct _xmlNode    *children;	/* NULL */
        struct _xmlNode        *last;	/* NULL */
        struct _xmlDtd       *parent;	/* -> DTD */
        struct _xmlNode        *next;	/* next sibling link  */
        struct _xmlNode        *prev;	/* previous sibling link  */
        struct _xmlDoc          *doc;       /* the containing document */

        struct _xmlAttribute  *nexth;	/* next in hash table */
        xmlAttributeType       atype;	/* The attribute type */
        xmlAttributeDefault      def;	/* the default */
        const xmlChar  *defaultValue;	/* or the default value */
        xmlEnumerationPtr       tree;       /* or the enumeration tree if any */
        const xmlChar        *prefix;	/* the namespace prefix if any */
        const xmlChar          *elem;	/* Element holding the attribute */
    };

an Attribute declaration in a DTD

### xmlAttributePtr

### enum xmlElementContentType

    typedef enum {
        XML_ELEMENT_CONTENT_PCDATA = 1,
        XML_ELEMENT_CONTENT_ELEMENT,
        XML_ELEMENT_CONTENT_SEQ,
        XML_ELEMENT_CONTENT_OR
    } xmlElementContentType;

Possible definitions of element content types

### enum xmlElementContentOccur

    typedef enum {
        XML_ELEMENT_CONTENT_ONCE = 1,
        XML_ELEMENT_CONTENT_OPT,
        XML_ELEMENT_CONTENT_MULT,
        XML_ELEMENT_CONTENT_PLUS
    } xmlElementContentOccur;

Possible definitions of element content occurences

### struct xmlElementContent

    struct xmlElementContent {
        xmlElementContentType     type;	/* PCDATA, ELEMENT, SEQ or OR */
        xmlElementContentOccur    ocur;	/* ONCE, OPT, MULT or PLUS */
        const xmlChar            *name;	/* Element name */
        struct _xmlElementContent *c1;	/* first child */
        struct _xmlElementContent *c2;	/* second child */
        struct _xmlElementContent *parent;	/* parent */
    };

an XML Element content as stored after parsing an element definition in a DTD.

### xmlElementContentPtr

### enum xmlElementTypeVal

    typedef enum {
        XML_ELEMENT_TYPE_UNDEFINED = 0,
        XML_ELEMENT_TYPE_EMPTY = 1,
        XML_ELEMENT_TYPE_ANY,
        XML_ELEMENT_TYPE_MIXED,
        XML_ELEMENT_TYPE_ELEMENT
    } xmlElementTypeVal;

the differnt possibility for an element content type

### struct xmlElement

    struct xmlElement {
        void           *_private;	        /* for Corba, must be first ! */
        xmlElementType          type;       /* XML_ELEMENT_DECL, must be second ! */
        const xmlChar          *name;	/* Element name */
        struct _xmlNode    *children;	/* NULL */
        struct _xmlNode        *last;	/* NULL */
        struct _xmlDtd       *parent;	/* -> DTD */
        struct _xmlNode        *next;	/* next sibling link  */
        struct _xmlNode        *prev;	/* previous sibling link  */
        struct _xmlDoc          *doc;       /* the containing document */

        xmlElementTypeVal      etype;	/* The type */
        xmlElementContentPtr content;	/* the allowed element content */
        xmlAttributePtr   attributes;	/* List of the declared attributes */
        const xmlChar        *prefix;	/* the namespace prefix if any */
    };

an XML Element declaration from a DTD

### xmlElementPtr

### XML_LOCAL_NAMESPACE

    #define     XML_LOCAL_NAMESPACE

### xmlNsType

### struct xmlNs

    struct xmlNs {
        struct _xmlNs  *next;	/* next Ns link for this node  */
        xmlNsType      type;	/* global or local */
        const xmlChar *href;	/* URL for the namespace */
        const xmlChar *prefix;	/* prefix for the namespace */
    };

An XML namespace. Note that prefix == NULL is valid, it defines the default namespace within the subtree (until overriden).

XML_GLOBAL_NAMESPACE is now deprecated for good xmlNsType is unified with xmlElementType

### xmlNsPtr

### struct xmlDtd

    struct xmlDtd {
        void           *_private;	/* for Corba, must be first ! */
        xmlElementType  type;       /* XML_DTD_NODE, must be second ! */
        const xmlChar *name;	/* Name of the DTD */
        struct _xmlNode *children;	/* the value of the property link */
        struct _xmlNode *last;	/* last child link */
        struct _xmlDoc  *parent;	/* child->parent link */
        struct _xmlNode *next;	/* next sibling link  */
        struct _xmlNode *prev;	/* previous sibling link  */
        struct _xmlDoc  *doc;	/* the containing document */

        /* End of common part */
        void          *notations;   /* Hash table for notations if any */
        void          *elements;    /* Hash table for elements if any */
        void          *attributes;  /* Hash table for attributes if any */
        void          *entities;    /* Hash table for entities if any */
        const xmlChar *ExternalID;	/* External identifier for PUBLIC DTD */
        const xmlChar *SystemID;	/* URI for a SYSTEM or PUBLIC DTD */
        void          *pentities;   /* Hash table for param entities if any */
    };

An XML DtD, as defined by <!DOCTYPE ... There is actually one for the internal subset and for the external subset

### xmlDtdPtr

### struct xmlAttr

    struct xmlAttr {
        void           *_private;	/* for Corba, must be first ! */
        xmlElementType   type;      /* XML_ATTRIBUTE_NODE, must be second ! */
        const xmlChar   *name;      /* the name of the property */
        struct _xmlNode *children;	/* the value of the property */
        struct _xmlNode *last;	/* NULL */
        struct _xmlNode *parent;	/* child->parent link */
        struct _xmlAttr *next;	/* next sibling link  */
        struct _xmlAttr *prev;	/* previous sibling link  */
        struct _xmlDoc  *doc;	/* the containing document */
        xmlNs           *ns;        /* pointer to the associated namespace */
        xmlAttributeType atype;     /* the attribute type if validating */
    };

A attribute on an XML node.

### xmlAttrPtr

### struct xmlID

    struct xmlID {
        struct _xmlID    *next;	/* next ID */
        const xmlChar    *value;	/* The ID name */
        xmlAttrPtr        attr;	/* The attribut holding it */
    };

An XML ID instance.

### xmlIDPtr

### struct xmlRef

    struct xmlRef {
        struct _xmlRef    *next;	/* next Ref */
        const xmlChar     *value;	/* The Ref name */
        xmlAttrPtr        attr;	/* The attribut holding it */
    };

An XML IDREF instance.

### xmlRefPtr

### enum xmlBufferAllocationScheme

    typedef enum {
        XML_BUFFER_ALLOC_DOUBLEIT,
        XML_BUFFER_ALLOC_EXACT
    } xmlBufferAllocationScheme;

A buffer allocation scheme can be defined to either match exactly the need or double it's allocated size each time it is found too small

### struct xmlBuffer

    struct xmlBuffer {
        xmlChar *content;		/* The buffer content UTF8 */
        unsigned int use;		/* The buffer size used */
        unsigned int size;		/* The buffer size */
        xmlBufferAllocationScheme alloc; /* The realloc method */
    };

A buffer structure

### xmlBufferPtr

### struct xmlNode

    struct xmlNode {
        void           *_private;	/* for Corba, must be first ! */
        xmlElementType   type;	/* type number, must be second ! */
        const xmlChar   *name;      /* the name of the node, or the entity */
        struct _xmlNode *children;	/* parent->childs link */
        struct _xmlNode *last;	/* last child link */
        struct _xmlNode *parent;	/* child->parent link */
        struct _xmlNode *next;	/* next sibling link  */
        struct _xmlNode *prev;	/* previous sibling link  */
        struct _xmlDoc  *doc;	/* the containing document */
        xmlNs           *ns;        /* pointer to the associated namespace */
    #ifndef XML_USE_BUFFER_CONTENT
        xmlChar         *content;   /* the content */
    #else
        xmlBufferPtr     content;   /* the content in a buffer */
    #endif

        /* End of common part */
        struct _xmlAttr *properties;/* properties list */
        xmlNs           *nsDef;     /* namespace definitions on this node */
    };

A node in an XML tree.

### xmlNodePtr

### struct xmlDoc

    struct xmlDoc {
        void           *_private;	/* for Corba, must be first ! */
        xmlElementType  type;       /* XML_DOCUMENT_NODE, must be second ! */
        char           *name;	/* name/filename/URI of the document */
        struct _xmlNode *children;	/* the document tree */
        struct _xmlNode *last;	/* last child link */
        struct _xmlNode *parent;	/* child->parent link */
        struct _xmlNode *next;	/* next sibling link  */
        struct _xmlNode *prev;	/* previous sibling link  */
        struct _xmlDoc  *doc;	/* autoreference to itself */

        /* End of common part */
        int             compression;/* level of zlib compression */
        int             standalone; /* standalone document (no external refs) */
        struct _xmlDtd  *intSubset;	/* the document internal subset */
        struct _xmlDtd  *extSubset;	/* the document external subset */
        struct _xmlNs   *oldNs;	/* Global namespace, the old way */
        const xmlChar  *version;	/* the XML version string */
        const xmlChar  *encoding;   /* external initial encoding, if any */
        void           *ids;        /* Hash table for ID attributes if any */
        void           *refs;       /* Hash table for IDREFs attributes if any */
        const xmlChar  *URL;	/* The URI for that document */
        int             charset;    /* encoding of the in-memory content
    				   actually an xmlCharEncoding */
    };

An XML document.

### xmlDocPtr

### xmlChildrenNode

    #define     xmlChildrenNode

Macro for compatibility naming layer with libxml1

### xmlRootNode

    #define     xmlRootNode

Macro for compatibility naming layer with libxml1

### xmlSetBufferAllocationScheme ()

    void        xmlSetBufferAllocationScheme    (xmlBufferAllocationScheme scheme);

Set the buffer allocation method. Types are XML_BUFFER_ALLOC_EXACT - use exact sizes, keeps memory usage down XML_BUFFER_ALLOC_DOUBLEIT - double buffer when extra needed, improves performance

`scheme` : |

### xmlGetBufferAllocationScheme ()

    xmlBufferAllocationScheme xmlGetBufferAllocationScheme
                                                (void);

Types are XML_BUFFER_ALLOC_EXACT - use exact sizes, keeps memory usage down XML_BUFFER_ALLOC_DOUBLEIT - double buffer when extra needed, improves performance

Returns : |

### xmlBufferCreate ()

    xmlBufferPtr xmlBufferCreate                (void);

routine to create an XML buffer.

Returns : |

### xmlBufferCreateSize ()

    xmlBufferPtr xmlBufferCreateSize            (size_t size);

routine to create an XML buffer.

`size` : |
Returns : |

### xmlBufferResize ()

    int         xmlBufferResize                 (xmlBufferPtr buf,
                                                 unsigned int size);

Resize a buffer to accomodate minimum size of `size`.

`buf` : |
`size` : |
Returns : |

### xmlBufferFree ()

    void        xmlBufferFree                   (xmlBufferPtr buf);

Frees an XML buffer.

`buf` : |

### xmlBufferDump ()

    int         xmlBufferDump                   (FILE *file,
                                                 xmlBufferPtr buf);

Dumps an XML buffer to a FILE *.

`file` : |
`buf` : |
Returns : |

### xmlBufferAdd ()

    void        xmlBufferAdd                    (xmlBufferPtr buf,
                                                 const xmlChar *str,
                                                 int len);

Add a string range to an XML buffer. if len == -1, the lenght of str is recomputed.

`buf` : |
`str` : |
`len` : |

### xmlBufferAddHead ()

    void        xmlBufferAddHead                (xmlBufferPtr buf,
                                                 const xmlChar *str,
                                                 int len);

Add a string range to the beginning of an XML buffer. if len == -1, the lenght of `str` is recomputed.

`buf` : |
`str` : |
`len` : |

### xmlBufferCat ()

    void        xmlBufferCat                    (xmlBufferPtr buf,
                                                 const xmlChar *str);

Append a zero terminated string to an XML buffer.

`buf` : |
`str` : |

### xmlBufferCCat ()

    void        xmlBufferCCat                   (xmlBufferPtr buf,
                                                 const char *str);

Append a zero terminated C string to an XML buffer.

`buf` : |
`str` : |

### xmlBufferShrink ()

    int         xmlBufferShrink                 (xmlBufferPtr buf,
                                                 unsigned int len);

Remove the beginning of an XML buffer.

`buf` : |
`len` : |
Returns : |

### xmlBufferGrow ()

    int         xmlBufferGrow                   (xmlBufferPtr buf,
                                                 unsigned int len);

Grow the available space of an XML buffer.

`buf` : |
`len` : |
Returns : |

### xmlBufferEmpty ()

    void        xmlBufferEmpty                  (xmlBufferPtr buf);

empty a buffer.

`buf` : |

### xmlBufferContent ()

    const xmlChar* xmlBufferContent             (const xmlBufferPtr buf);

`buf` : |
Returns : |

### xmlBufferUse ()

    int         xmlBufferUse                    (const xmlBufferPtr buf);

`buf` : |
Returns : |

### xmlBufferSetAllocationScheme ()

    void        xmlBufferSetAllocationScheme    (xmlBufferPtr buf,
                                                 xmlBufferAllocationScheme scheme);

Sets the allocation scheme for this buffer

`buf` : |
`scheme` : |

### xmlBufferLength ()

    int         xmlBufferLength                 (const xmlBufferPtr buf);

`buf` : |
Returns : |

### xmlCreateIntSubset ()

    xmlDtdPtr   xmlCreateIntSubset              (xmlDocPtr doc,
                                                 const xmlChar *name,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);

Create the internal subset of a document

`doc` : |
`name` : |
`ExternalID` : |
`SystemID` : |
Returns : |

### xmlNewDtd ()

    xmlDtdPtr   xmlNewDtd                       (xmlDocPtr doc,
                                                 const xmlChar *name,
                                                 const xmlChar *ExternalID,
                                                 const xmlChar *SystemID);

Creation of a new DTD for the external subset. To create an internal subset, use xmlCreateIntSubset().

`doc` : |
`name` : |
`ExternalID` : |
`SystemID` : |
Returns : |

### xmlGetIntSubset ()

    xmlDtdPtr   xmlGetIntSubset                 (xmlDocPtr doc);

Get the internal subset of a document

`doc` : |
Returns : |

### xmlFreeDtd ()

    void        xmlFreeDtd                      (xmlDtdPtr cur);

Free a DTD structure.

`cur` : |

### xmlNewGlobalNs ()

    xmlNsPtr    xmlNewGlobalNs                  (xmlDocPtr doc,
                                                 const xmlChar *href,
                                                 const xmlChar *prefix);

Creation of a Namespace, the old way using PI and without scoping DEPRECATED !!! It now create a namespace on the root element of the document if found.

`doc` : |
`href` : |
`prefix` : |
Returns : |

### xmlNewNs ()

    xmlNsPtr    xmlNewNs                        (xmlNodePtr node,
                                                 const xmlChar *href,
                                                 const xmlChar *prefix);

Creation of a new Namespace. This function will refuse to create a namespace with a similar prefix than an existing one present on this node. We use href==NULL in the case of an element creation where the namespace was not defined.

`node` : |
`href` : |
`prefix` : |
Returns : |

### xmlFreeNs ()

    void        xmlFreeNs                       (xmlNsPtr cur);

Free up the structures associated to a namespace

`cur` : |

### xmlFreeNsList ()

    void        xmlFreeNsList                   (xmlNsPtr cur);

Free up all the structures associated to the chained namespaces.

`cur` : |

### xmlNewDoc ()

    xmlDocPtr   xmlNewDoc                       (const xmlChar *version);

`version` : |
Returns : |

### xmlFreeDoc ()

    void        xmlFreeDoc                      (xmlDocPtr cur);

Free up all the structures used by a document, tree included.

`cur` : |

### xmlNewDocProp ()

    xmlAttrPtr  xmlNewDocProp                   (xmlDocPtr doc,
                                                 const xmlChar *name,
                                                 const xmlChar *value);

Create a new property carried by a document.

`doc` : |
`name` : |
`value` : |
Returns : |

### xmlNewProp ()

    xmlAttrPtr  xmlNewProp                      (xmlNodePtr node,
                                                 const xmlChar *name,
                                                 const xmlChar *value);

Create a new property carried by a node.

`node` : |
`name` : |
`value` : |
Returns : |

### xmlNewNsProp ()

    xmlAttrPtr  xmlNewNsProp                    (xmlNodePtr node,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *value);

Create a new property tagged with a namespace and carried by a node.

`node` : |
`ns` : |
`name` : |
`value` : |
Returns : |

### xmlFreePropList ()

    void        xmlFreePropList                 (xmlAttrPtr cur);

Free a property and all its siblings, all the children are freed too.

`cur` : |

### xmlFreeProp ()

    void        xmlFreeProp                     (xmlAttrPtr cur);

Free one attribute, all the content is freed too

`cur` : |

### xmlCopyProp ()

    xmlAttrPtr  xmlCopyProp                     (xmlNodePtr target,
                                                 xmlAttrPtr cur);

Do a copy of the attribute.

`target` : |
`cur` : |
Returns : |

### xmlCopyPropList ()

    xmlAttrPtr  xmlCopyPropList                 (xmlNodePtr target,
                                                 xmlAttrPtr cur);

Do a copy of an attribute list.

`target` : |
`cur` : |
Returns : |

### xmlCopyDtd ()

    xmlDtdPtr   xmlCopyDtd                      (xmlDtdPtr dtd);

Do a copy of the dtd.

`dtd` : |
Returns : |

### xmlCopyDoc ()

    xmlDocPtr   xmlCopyDoc                      (xmlDocPtr doc,
                                                 int recursive);

Do a copy of the document info. If recursive, the content tree will be copied too as well as Dtd, namespaces and entities.

`doc` : |
`recursive` : |
Returns : |

### xmlNewDocNode ()

    xmlNodePtr  xmlNewDocNode                   (xmlDocPtr doc,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *content);

Creation of a new node element within a document. `ns` and `content` are optionnal (NULL). NOTE: `content` is supposed to be a piece of XML CDATA, so it allow entities references, but XML special chars need to be escaped first by using xmlEncodeEntitiesReentrant(). Use xmlNewDocRawNode() if you don't need entities support.

`doc` : |
`ns` : |
`name` : |
`content` : |
Returns : |

### xmlNewDocRawNode ()

    xmlNodePtr  xmlNewDocRawNode                (xmlDocPtr doc,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *content);

Creation of a new node element within a document. `ns` and `content` are optionnal (NULL).

`doc` : |
`ns` : |
`name` : |
`content` : |
Returns : |

### xmlNewNode ()

    xmlNodePtr  xmlNewNode                      (xmlNsPtr ns,
                                                 const xmlChar *name);

Creation of a new node element. `ns` is optionnal (NULL).

`ns` : |
`name` : |
Returns : |

### xmlNewChild ()

    xmlNodePtr  xmlNewChild                     (xmlNodePtr parent,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *content);

Creation of a new child element, added at the end of `parent` children list. `ns` and `content` parameters are optionnal (NULL). If content is non NULL, a child list containing the TEXTs and ENTITY_REFs node will be created. NOTE: `content` is supposed to be a piece of XML CDATA, so it allow entities references, but XML special chars need to be escaped first by using xmlEncodeEntitiesReentrant(). Use xmlNewTextChild() if entities support is not needed.

`parent` : |
`ns` : |
`name` : |
`content` : |
Returns : |

### xmlNewTextChild ()

    xmlNodePtr  xmlNewTextChild                 (xmlNodePtr parent,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *content);

Creation of a new child element, added at the end of `parent` children list. `ns` and `content` parameters are optionnal (NULL). If content is non NULL, a child TEXT node will be created containing the string content.

`parent` : |
`ns` : |
`name` : |
`content` : |
Returns : |

### xmlNewDocText ()

    xmlNodePtr  xmlNewDocText                   (xmlDocPtr doc,
                                                 const xmlChar *content);

Creation of a new text node within a document.

`doc` : |
`content` : |
Returns : |

### xmlNewText ()

    xmlNodePtr  xmlNewText                      (const xmlChar *content);

Creation of a new text node.

`content` : |
Returns : |

### xmlNewPI ()

    xmlNodePtr  xmlNewPI                        (const xmlChar *name,
                                                 const xmlChar *content);

Creation of a processing instruction element.

`name` : |
`content` : |
Returns : |

### xmlNewDocTextLen ()

    xmlNodePtr  xmlNewDocTextLen                (xmlDocPtr doc,
                                                 const xmlChar *content,
                                                 int len);

Creation of a new text node with an extra content lenght parameter. The text node pertain to a given document.

`doc` : |
`content` : |
`len` : |
Returns : |

### xmlNewTextLen ()

    xmlNodePtr  xmlNewTextLen                   (const xmlChar *content,
                                                 int len);

Creation of a new text node with an extra parameter for the content's lenght

`content` : |
`len` : |
Returns : |

### xmlNewDocComment ()

    xmlNodePtr  xmlNewDocComment                (xmlDocPtr doc,
                                                 const xmlChar *content);

Creation of a new node containing a commentwithin a document.

`doc` : |
`content` : |
Returns : |

### xmlNewComment ()

    xmlNodePtr  xmlNewComment                   (const xmlChar *content);

Creation of a new node containing a comment.

`content` : |
Returns : |

### xmlNewCDataBlock ()

    xmlNodePtr  xmlNewCDataBlock                (xmlDocPtr doc,
                                                 const xmlChar *content,
                                                 int len);

Creation of a new node containing a CData block.

`doc` : |
`content` : |
`len` : |
Returns : |

### xmlNewCharRef ()

    xmlNodePtr  xmlNewCharRef                   (xmlDocPtr doc,
                                                 const xmlChar *name);

Creation of a new character reference node.

`doc` : |
`name` : |
Returns : |

### xmlNewReference ()

    xmlNodePtr  xmlNewReference                 (xmlDocPtr doc,
                                                 const xmlChar *name);

Creation of a new reference node.

`doc` : |
`name` : |
Returns : |

### xmlCopyNode ()

    xmlNodePtr  xmlCopyNode                     (xmlNodePtr node,
                                                 int recursive);

Do a copy of the node.

`node` : |
`recursive` : |
Returns : |

### xmlDocCopyNode ()

    xmlNodePtr  xmlDocCopyNode                  (xmlNodePtr node,
                                                 xmlDocPtr doc,
                                                 int recursive);

Do a copy of the node to a given document.

`node` : |
`doc` : |
`recursive` : |
Returns : |

### xmlCopyNodeList ()

    xmlNodePtr  xmlCopyNodeList                 (xmlNodePtr node);

Do a recursive copy of the node list.

`node` : |
Returns : |

### xmlNewDocFragment ()

    xmlNodePtr  xmlNewDocFragment               (xmlDocPtr doc);

Creation of a new Fragment node.

`doc` : |
Returns : |

### xmlDocGetRootElement ()

    xmlNodePtr  xmlDocGetRootElement            (xmlDocPtr doc);

Get the root element of the document (doc->children is a list containing possibly comments, PIs, etc ...).

`doc` : |
Returns : |

### xmlGetLastChild ()

    xmlNodePtr  xmlGetLastChild                 (xmlNodePtr parent);

Search the last child of a node.

`parent` : |
Returns : |

### xmlNodeIsText ()

    int         xmlNodeIsText                   (xmlNodePtr node);

Is this node a Text node ?

`node` : |
Returns : |

### xmlIsBlankNode ()

    int         xmlIsBlankNode                  (xmlNodePtr node);

Checks whether this node is an empty or whitespace only (and possibly ignorable) text-node.

`node` : |
Returns : |

### xmlDocSetRootElement ()

    xmlNodePtr  xmlDocSetRootElement            (xmlDocPtr doc,
                                                 xmlNodePtr root);

Set the root element of the document (doc->children is a list containing possibly comments, PIs, etc ...).

`doc` : |
`root` : |
Returns : |

### xmlNodeSetName ()

    void        xmlNodeSetName                  (xmlNodePtr cur,
                                                 const xmlChar *name);

Set (or reset) the name of a node.

`cur` : |
`name` : |

### xmlAddChild ()

    xmlNodePtr  xmlAddChild                     (xmlNodePtr parent,
                                                 xmlNodePtr cur);

Add a new child element, to `parent`, at the end of the child list merging adjacent TEXT nodes (in which case `cur` is freed)

`parent` : |
`cur` : |
Returns : |

### xmlAddChildList ()

    xmlNodePtr  xmlAddChildList                 (xmlNodePtr parent,
                                                 xmlNodePtr cur);

Add a list of node at the end of the child list of the parent merging adjacent TEXT nodes (`cur` may be freed)

`parent` : |
`cur` : |
Returns : |

### xmlReplaceNode ()

    xmlNodePtr  xmlReplaceNode                  (xmlNodePtr old,
                                                 xmlNodePtr cur);

Unlink the old node from it's current context, prune the new one at the same place. If cur was already inserted in a document it is first unlinked from its existing context.

`old` : |
`cur` : |
Returns : |

### xmlAddSibling ()

    xmlNodePtr  xmlAddSibling                   (xmlNodePtr cur,
                                                 xmlNodePtr elem);

Add a new element `elem` to the list of siblings of `cur` merging adjacent TEXT nodes (`elem` may be freed) If the new element was already inserted in a document it is first unlinked from its existing context.

`cur` : |
`elem` : |
Returns : |

### xmlAddPrevSibling ()

    xmlNodePtr  xmlAddPrevSibling               (xmlNodePtr cur,
                                                 xmlNodePtr elem);

Add a new element `elem` as the previous siblings of `cur` merging adjacent TEXT nodes (`elem` may be freed) If the new element was already inserted in a document it is first unlinked from its existing context.

`cur` : |
`elem` : |
Returns : |

### xmlAddNextSibling ()

    xmlNodePtr  xmlAddNextSibling               (xmlNodePtr cur,
                                                 xmlNodePtr elem);

Add a new element `elem` as the next siblings of `cur` If the new element was already inserted in a document it is first unlinked from its existing context. As a result of text merging `elem` may be freed.

`cur` : |
`elem` : |
Returns : |

### xmlUnlinkNode ()

    void        xmlUnlinkNode                   (xmlNodePtr cur);

Unlink a node from it's current context, the node is not freed

`cur` : |

### xmlTextMerge ()

    xmlNodePtr  xmlTextMerge                    (xmlNodePtr first,
                                                 xmlNodePtr second);

Merge two text nodes into one

`first` : |
`second` : |
Returns : |

### xmlTextConcat ()

    void        xmlTextConcat                   (xmlNodePtr node,
                                                 const xmlChar *content,
                                                 int len);

Concat the given string at the end of the existing node content

`node` : |
`content` : |
`len` : |

### xmlFreeNodeList ()

    void        xmlFreeNodeList                 (xmlNodePtr cur);

Free a node and all its siblings, this is a recursive behaviour, all the children are freed too.

`cur` : |

### xmlFreeNode ()

    void        xmlFreeNode                     (xmlNodePtr cur);

Free a node, this is a recursive behaviour, all the children are freed too. This doesn't unlink the child from the list, use xmlUnlinkNode() first.

`cur` : |

### xmlSetTreeDoc ()

    void        xmlSetTreeDoc                   (xmlNodePtr tree,
                                                 xmlDocPtr doc);

update all nodes under the tree to point to the right document

`tree` : |
`doc` : |

### xmlSetListDoc ()

    void        xmlSetListDoc                   (xmlNodePtr list,
                                                 xmlDocPtr doc);

update all nodes in the list to point to the right document

`list` : |
`doc` : |

### xmlSearchNs ()

    xmlNsPtr    xmlSearchNs                     (xmlDocPtr doc,
                                                 xmlNodePtr node,
                                                 const xmlChar *nameSpace);

Search a Ns registered under a given name space for a document. recurse on the parents until it finds the defined namespace or return NULL otherwise. `nameSpace` can be NULL, this is a search for the default namespace. We don't allow to cross entities boundaries. If you don't declare the namespace within those you will be in troubles !!! A warning is generated to cover this case.

`doc` : |
`node` : |
`nameSpace` : |
Returns : |

### xmlSearchNsByHref ()

    xmlNsPtr    xmlSearchNsByHref               (xmlDocPtr doc,
                                                 xmlNodePtr node,
                                                 const xmlChar *href);

Search a Ns aliasing a given URI. Recurse on the parents until it finds the defined namespace or return NULL otherwise.

`doc` : |
`node` : |
`href` : |
Returns : |

### xmlGetNsList ()

    xmlNsPtr*   xmlGetNsList                    (xmlDocPtr doc,
                                                 xmlNodePtr node);

Search all the namespace applying to a given element.

`doc` : |
`node` : |
Returns : |

### xmlSetNs ()

    void        xmlSetNs                        (xmlNodePtr node,
                                                 xmlNsPtr ns);

Associate a namespace to a node, a posteriori.

`node` : |
`ns` : |

### xmlCopyNamespace ()

    xmlNsPtr    xmlCopyNamespace                (xmlNsPtr cur);

Do a copy of the namespace.

`cur` : |
Returns : |

### xmlCopyNamespaceList ()

    xmlNsPtr    xmlCopyNamespaceList            (xmlNsPtr cur);

Do a copy of an namespace list.

`cur` : |
Returns : |

### xmlSetProp ()

    xmlAttrPtr  xmlSetProp                      (xmlNodePtr node,
                                                 const xmlChar *name,
                                                 const xmlChar *value);

Set (or reset) an attribute carried by a node.

`node` : |
`name` : |
`value` : |
Returns : |

### xmlGetProp ()

    xmlChar*    xmlGetProp                      (xmlNodePtr node,
                                                 const xmlChar *name);

Search and get the value of an attribute associated to a node This does the entity substitution. This function looks in DTD attribute declaration for FIXED or default declaration values unless DTD use has been turned off.

`node` : |
`name` : |
Returns : |

### xmlHasProp ()

    xmlAttrPtr  xmlHasProp                      (xmlNodePtr node,
                                                 const xmlChar *name);

Search an attribute associated to a node This function also looks in DTD attribute declaration for FIXED or default declaration values unless DTD use has been turned off.

`node` : |
`name` : |
Returns : |

### xmlHasNsProp ()

    xmlAttrPtr  xmlHasNsProp                    (xmlNodePtr node,
                                                 const xmlChar *name,
                                                 const xmlChar *nameSpace);

Search for an attribute associated to a node This attribute has to be anchored in the namespace specified. This does the entity substitution. This function looks in DTD attribute declaration for FIXED or default declaration values unless DTD use has been turned off.

`node` : |
`name` : |
`nameSpace` : |
Returns : |

### xmlSetNsProp ()

    xmlAttrPtr  xmlSetNsProp                    (xmlNodePtr node,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name,
                                                 const xmlChar *value);

Set (or reset) an attribute carried by a node. The ns structure must be in scope, this is not checked.

`node` : |
`ns` : |
`name` : |
`value` : |
Returns : |

### xmlGetNsProp ()

    xmlChar*    xmlGetNsProp                    (xmlNodePtr node,
                                                 const xmlChar *name,
                                                 const xmlChar *nameSpace);

Search and get the value of an attribute associated to a node This attribute has to be anchored in the namespace specified. This does the entity substitution. This function looks in DTD attribute declaration for FIXED or default declaration values unless DTD use has been turned off.

`node` : |
`name` : |
`nameSpace` : |
Returns : |

### xmlStringGetNodeList ()

    xmlNodePtr  xmlStringGetNodeList            (xmlDocPtr doc,
                                                 const xmlChar *value);

Parse the value string and build the node list associated. Should produce a flat tree with only TEXTs and ENTITY_REFs.

`doc` : |
`value` : |
Returns : |

### xmlStringLenGetNodeList ()

    xmlNodePtr  xmlStringLenGetNodeList         (xmlDocPtr doc,
                                                 const xmlChar *value,
                                                 int len);

Parse the value string and build the node list associated. Should produce a flat tree with only TEXTs and ENTITY_REFs.

`doc` : |
`value` : |
`len` : |
Returns : |

### xmlNodeListGetString ()

    xmlChar*    xmlNodeListGetString            (xmlDocPtr doc,
                                                 xmlNodePtr list,
                                                 int inLine);

Returns the string equivalent to the text contained in the Node list made of TEXTs and ENTITY_REFs

`doc` : |
`list` : |
`inLine` : |
Returns : |

### xmlNodeListGetRawString ()

    xmlChar*    xmlNodeListGetRawString         (xmlDocPtr doc,
                                                 xmlNodePtr list,
                                                 int inLine);

Returns the string equivalent to the text contained in the Node list made of TEXTs and ENTITY_REFs, contrary to xmlNodeListGetString() this function doesn't do any character encoding handling.

`doc` : |
`list` : |
`inLine` : |
Returns : |

### xmlNodeSetContent ()

    void        xmlNodeSetContent               (xmlNodePtr cur,
                                                 const xmlChar *content);

Replace the content of a node.

`cur` : |
`content` : |

### xmlNodeSetContentLen ()

    void        xmlNodeSetContentLen            (xmlNodePtr cur,
                                                 const xmlChar *content,
                                                 int len);

Replace the content of a node.

`cur` : |
`content` : |
`len` : |

### xmlNodeAddContent ()

    void        xmlNodeAddContent               (xmlNodePtr cur,
                                                 const xmlChar *content);

Append the extra substring to the node content.

`cur` : |
`content` : |

### xmlNodeAddContentLen ()

    void        xmlNodeAddContentLen            (xmlNodePtr cur,
                                                 const xmlChar *content,
                                                 int len);

Append the extra substring to the node content.

`cur` : |
`content` : |
`len` : |

### xmlNodeGetContent ()

    xmlChar*    xmlNodeGetContent               (xmlNodePtr cur);

Read the value of a node, this can be either the text carried directly by this node if it's a TEXT node or the aggregate string of the values carried by this node child's (TEXT and ENTITY_REF). Entity references are substitued.

`cur` : |
Returns : |

### xmlNodeGetLang ()

    xmlChar*    xmlNodeGetLang                  (xmlNodePtr cur);

Searches the language of a node, i.e. the values of the xml:lang attribute or the one carried by the nearest ancestor.

`cur` : |
Returns : |

### xmlNodeSetLang ()

    void        xmlNodeSetLang                  (xmlNodePtr cur,
                                                 const xmlChar *lang);

Set the language of a node, i.e. the values of the xml:lang attribute.

`cur` : |
`lang` : |

### xmlNodeGetSpacePreserve ()

    int         xmlNodeGetSpacePreserve         (xmlNodePtr cur);

Searches the space preserving behaviour of a node, i.e. the values of the xml:space attribute or the one carried by the nearest ancestor.

`cur` : |
Returns : |

### xmlNodeSetSpacePreserve ()

    void        xmlNodeSetSpacePreserve         (xmlNodePtr cur,
                                                 intval);

Set (or reset) the space preserving behaviour of a node, i.e. the value of the xml:space attribute.

`cur` : |
`Param2` : |

### xmlNodeGetBase ()

    xmlChar*    xmlNodeGetBase                  (xmlDocPtr doc,
                                                 xmlNodePtr cur);

Searches for the BASE URL. The code should work on both XML and HTML document even if base mechanisms are completely different. It returns the base as defined in RFC 2396 sections 5.1.1. Base URI within Document Content and 5.1.2. Base URI from the Encapsulating Entity However it does not return the document base (5.1.3), use xmlDocumentGetBase() for this

`doc` : |
`cur` : |
Returns : |

### xmlNodeSetBase ()

    void        xmlNodeSetBase                  (xmlNodePtr cur,
                                                 xmlChar *uri);

Set (or reset) the base URI of a node, i.e. the value of the xml:base attribute.

`cur` : |
`uri` : |

### xmlRemoveProp ()

    int         xmlRemoveProp                   (xmlAttrPtr attr);

Unlink and free one attribute, all the content is freed too Note this doesn't work for namespace definition attributes

`attr` : |
Returns : |

### xmlRemoveNode ()

    int         xmlRemoveNode                   (xmlNodePtr node);

`node` : |
Returns : |

### xmlUnsetProp ()

    int         xmlUnsetProp                    (xmlNodePtr node,
                                                 const xmlChar *name);

Remove an attribute carried by a node.

`node` : |
`name` : |
Returns : |

### xmlUnsetNsProp ()

    int         xmlUnsetNsProp                  (xmlNodePtr node,
                                                 xmlNsPtr ns,
                                                 const xmlChar *name);

Remove an attribute carried by a node.

`node` : |
`ns` : |
`name` : |
Returns : |

### xmlBufferWriteXmlCHAR ()

    void        xmlBufferWriteXmlCHAR           (xmlBufferPtr buf,
                                                 const xmlChar *string);

`buf` : |
`string` : |

### xmlBufferWriteCHAR ()

    void        xmlBufferWriteCHAR              (xmlBufferPtr buf,
                                                 const xmlChar *string);

routine which manages and grows an output buffer. This one adds xmlChars at the end of the buffer.

`buf` : |
`string` : |

### xmlBufferWriteChar ()

    void        xmlBufferWriteChar              (xmlBufferPtr buf,
                                                 const char *string);

routine which manage and grows an output buffer. This one add C chars at the end of the array.

`buf` : |
`string` : |

### xmlBufferWriteQuotedString ()

    void        xmlBufferWriteQuotedString      (xmlBufferPtr buf,
                                                 const xmlChar *string);

routine which manage and grows an output buffer. This one writes a quoted or double quoted xmlChar string, checking first if it holds quote or double-quotes internally

`buf` : |
`string` : |

### xmlReconciliateNs ()

    int         xmlReconciliateNs               (xmlDocPtr doc,
                                                 xmlNodePtr tree);

This function checks that all the namespaces declared within the given tree are properly declared. This is needed for example after Copy or Cut and then paste operations. The subtree may still hold pointers to namespace declarations outside the subtree or invalid/masked. As much as possible the function try tu reuse the existing namespaces found in the new environment. If not possible the new namespaces are redeclared on `tree` at the top of the given subtree.

`doc` : |
`tree` : |
Returns : |

### xmlDocDumpFormatMemory ()

    void        xmlDocDumpFormatMemory          (xmlDocPtr cur,
                                                 xmlChar **mem,
                                                 int *size,
                                                 int format);

Dump an XML document in memory and return the xmlChar * and it's size. It's up to the caller to free the memory.

`cur` : |
`mem` : |
`size` : |
`format` : |

### xmlDocDumpMemory ()

    void        xmlDocDumpMemory                (xmlDocPtr cur,
                                                 xmlChar **mem,
                                                 int *size);

Dump an XML document in memory and return the xmlChar * and it's size. It's up to the caller to free the memory.

`cur` : |
`mem` : |
`size` : |

### xmlDocDumpMemoryEnc ()

    void        xmlDocDumpMemoryEnc             (xmlDocPtr out_doc,
                                                 xmlChar **doc_txt_ptr,
                                                 int *doc_txt_len,
                                                 const char *txt_encoding);

Dump the current DOM tree into memory using the character encoding specified by the caller. Note it is up to the caller of this function to free the allocated memory.

`out_doc` : |
`doc_txt_ptr` : |
`doc_txt_len` : |
`txt_encoding` : |

### xmlDocDumpFormatMemoryEnc ()

    void        xmlDocDumpFormatMemoryEnc       (xmlDocPtr out_doc,
                                                 xmlChar **doc_txt_ptr,
                                                 int *doc_txt_len,
                                                 const char *txt_encoding,
                                                 int format);

`out_doc` : |
`doc_txt_ptr` : |
`doc_txt_len` : |
`txt_encoding` : |
`format` : |

### xmlDocDump ()

    int         xmlDocDump                      (FILE *f,
                                                 xmlDocPtr cur);

Dump an XML document to an open FILE.

`f` : |
`cur` : |
Returns : |

### xmlElemDump ()

    void        xmlElemDump                     (FILE *f,
                                                 xmlDocPtr doc,
                                                 xmlNodePtr cur);

Dump an XML/HTML node, recursive behaviour,children are printed too.

`f` : |
`doc` : |
`cur` : |

### xmlSaveFile ()

    int         xmlSaveFile                     (const char *filename,
                                                 xmlDocPtr cur);

Dump an XML document to a file. Will use compression if compiled in and enabled. If `filename` is "-" the stdout file is used.

`filename` : |
`cur` : |
Returns : |

### xmlSaveFormatFile ()

    int         xmlSaveFormatFile               (const char *filename,
                                                 xmlDocPtr cur,
                                                 int format);

Dump an XML document to a file. Will use compression if compiled in and enabled. If `filename` is "-" the stdout file is used. If format is set then the document will be indented on output.

`filename` : |
`cur` : |
`format` : |
Returns : |

### xmlNodeDump ()

    void        xmlNodeDump                     (xmlBufferPtr buf,
                                                 xmlDocPtr doc,
                                                 xmlNodePtr cur,
                                                 int level,
                                                 int format);

Dump an XML node, recursive behaviour,children are printed too.

`buf` : |
`doc` : |
`cur` : |
`level` : |
`format` : |

### xmlSaveFileEnc ()

    int         xmlSaveFileEnc                  (const char *filename,
                                                 xmlDocPtr cur,
                                                 const char *encoding);

Dump an XML document, converting it to the given encoding

`filename` : |
`cur` : |
`encoding` : |
Returns : |

### xmlGetDocCompressMode ()

    int         xmlGetDocCompressMode           (xmlDocPtr doc);

get the compression ratio for a document, ZLIB based

`doc` : |
Returns : |

### xmlSetDocCompressMode ()

    void        xmlSetDocCompressMode           (xmlDocPtr doc,
                                                 int mode);

set the compression ratio for a document, ZLIB based Correct values: 0 (uncompressed) to 9 (max compression)

`doc` : |
`mode` : |

### xmlGetCompressMode ()

    int         xmlGetCompressMode              (void);

get the default compression mode used, ZLIB based.

Returns : |

### xmlSetCompressMode ()

    void        xmlSetCompressMode              (int mode);

set the default compression mode used, ZLIB based Correct values: 0 (uncompressed) to 9 (max compression)

`mode` : |

<<< Previous Page | Home | Up | Next Page >>>
SAX | entities